package com.zipcoder.payment;

public class CreditCard implements Payment {


    private  long id;
    private String payerName;
    private String number;
    int expiredMonth;
    int expiredYear;

    public CreditCard() {
        this.id = id;
        this.payerName = payerName;
        this.number = number;
        this.expiredMonth = expiredMonth;
        this.expiredYear = expiredYear;

    }


    public CreditCard(Long id, String payerName, String number, int expiredMonth, int expiredYear) {
        this.payerName = payerName;
        this.number = number;
        this.expiredMonth = expiredMonth;
        this.expiredYear = expiredYear;

    }

    public void setPayerName(String payerName) {
        this.payerName = payerName;
    }

    public String getNumber() {
        return number;
    }
    public String getLast4Digit() {
        String str="";
        if (number.length() == 4) {
            str= number;
        } else if (number.length() > 4) {
            str= number.substring(number.length() - 4);

        }
        return str;
    }

    public void setNumber(String number) {
        this.number = number;
    }

    public int getExpiredMonth() {
        return expiredMonth;
    }

    public void setExpiredMonth(int expiredMonth) {
        this.expiredMonth = expiredMonth;
    }

    public int getExpiredYear() {
        return expiredYear;
    }

    public void setExpiredYear(int expiredYear) {
        this.expiredYear = expiredYear;
    }

    @Override
    public Long getId() {

        return id;
    }

    @Override
    public String getPayerName() {

        return payerName;
    }

    @Override
    public String getShortDescription() {
    CreditCard cc = new CreditCard();

        return  "Credit Card  "+ payerName +" *** " + getLast4Digit()+ " "+ expiredMonth +"/" +expiredYear ;
    }


    public void setId(long id) {
        this.id = id;
    }

    @Override
    public int compareTo(Payment other) {
        return this.getShortDescription().compareTo(other.getShortDescription());

    }
}
